// ClientThread.cpp : implementation file
//

#include "stdafx.h"
#include "Chat.h"
#include "ClientThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClientThread

IMPLEMENT_DYNCREATE(CClientThread, CWinThread)

CClientThread::CClientThread()
{
	m_bAutoDelete = FALSE;
	nErrorCode = CLIENT_ERROR_NOERROR;
	m_bState = CLIENT_ORIGIN;
	m_hFinalWnd = NULL;
}


CClientThread::CClientThread(CString szHost, UINT nPort, BOOL bUseProxy, HWND hWnd, HWND hFinalWnd)
{
	m_bAutoDelete = FALSE;
	m_szHost = szHost;
	m_nPort = nPort;
	m_hMainWnd = hWnd;
	nErrorCode = CLIENT_ERROR_NOERROR;
	m_bUseProxy = bUseProxy;
	m_bState = CLIENT_ORIGIN;
	m_hWaitEvent = CreateEvent( NULL, FALSE, FALSE, NULL );
	m_hFinalWnd = hFinalWnd;
}

CClientThread::~CClientThread()
{
	m_bState = CLIENT_CLOSED;
}

BOOL CClientThread::InitInstance()
{
	int nResult;
	// TODO:  perform and per-thread initialization here
	//ӴڶҪӵƻIP
	//TCPSocketCreateClientʼ


	m_bState = CLIENT_CONNECTING;
	nResult = m_cTCPSocket.CreateClient( m_szHost, m_nPort, m_bUseProxy, m_hMainWnd, m_hFinalWnd);
	if( nResult == FALSE )
	{
		//ʧ
		//˳Ϣ
		//ش
		nResult = m_cTCPSocket.GetLastError();

		nErrorCode = CLIENT_ERROR_CREATE;
		m_bState = CLIENT_QUITING;
		PostMessage( m_hMainWnd, WM_THREAD_QUIT, FALSE, MAKELONG(nResult, FALSE) );
		//ȴԭڵKillThread˳
		SetEvent( m_hWaitEvent );
		return TRUE;
	}
	//ʼȴTCPSocketSOCKET_THREAD_CONNECT
	//߳Ϣ
	m_bState = CLIENT_WAITING;
	PostMessage( m_hMainWnd, WM_THREAD_CONNECT, 0, 0 );
	if( m_bUseProxy == FALSE )m_hMainWnd = m_hFinalWnd;
	SetEvent( m_hWaitEvent );
	
	return TRUE;
}

int CClientThread::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CClientThread, CWinThread)
	//{{AFX_MSG_MAP(CClientThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		ON_THREAD_MESSAGE( SOCKET_THREAD_READ, OnSocketRead )
		ON_THREAD_MESSAGE( SOCKET_THREAD_WRITE, OnSocketWrite )
		ON_THREAD_MESSAGE( SOCKET_THREAD_CLOSE, OnSocketClose )
		ON_THREAD_MESSAGE( WM_THREAD_DATA, OnThreadData )
		ON_THREAD_MESSAGE( WM_THREAD_QUIT, OnThreadQuit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClientThread message handlers

void CClientThread::KillThread()
{
	//Ѿرգܳ
	if( m_bState == CLIENT_CLOSED ) return;

	if( m_bState == CLIENT_CONNECTING )
	{
		//ֹ
		m_cTCPSocket.Stop();
	}
	PostThreadMessage( WM_QUIT, 0, 0 );
	WaitForSingleObject( m_hThread, INFINITE );
	delete this;
}

int CClientThread::GetLastError()
{
	return nErrorCode;
}

void CClientThread::OnSocketConnect()
{

	if( m_bState == CLIENT_CONNECTING )
		m_cTCPSocket.StopWait();
}


SOCKET CClientThread::GetSocket()
{
	return m_cTCPSocket.GetSocket();
}



void CClientThread::OnSocketRead(WPARAM wParam, LPARAM lParam)
{
	//յȷFD_READϢ
	//жݣڷϢ
	int nResult;
	LPBYTE lpTemp;
	int nLen;



	nResult = m_cTCPSocket.Receive();
	if( nResult )
	{
		lpTemp = m_cTCPSocket.GetData( &nLen );
		if( lpTemp )
			PostMessage( m_hMainWnd, WM_THREAD_DATA, nLen, (LPARAM)lpTemp );
	}
}

void CClientThread::OnSocketWrite(WPARAM wParam, LPARAM lParam)
{
	//յȷFD_WRITEϢ
	////˵Ѿ


	m_cTCPSocket.EnableWrite();
}

void CClientThread::OnSocketClose(WPARAM wParam, LPARAM lParam)
{
	//յȷFD_CLOSEϢ
	////˵socketѾر
	///߳ûյ˳Ϣյ֪ͨ˳
	////˵·жϣ˳߳


	if( m_bState == CLIENT_WAITING )
	{
		m_bState = CLIENT_QUITING;
		PostMessage( m_hMainWnd, WM_THREAD_QUIT, FALSE, MAKELONG(SOCKET_ERROR_CLOSE, FALSE) );		
	}
	////򲻴
	return;
}

void CClientThread::OnThreadData(WPARAM wParam, LPARAM lParam)
{
	//wParamʾҪ͵ֽ
	//lParamָ
	int nResult;

	//Clienṯ߳ͬ	

	nResult = m_cTCPSocket.Send( (LPBYTE)lParam, wParam );
	switch( nResult )
	{
	case SOCKET_ERROR_NOERROR:
			::PostMessage( m_hMainWnd, SOCKET_THREAD_WRITE, TRUE, 0 );
			break;
	default:
			::PostMessage( m_hMainWnd, SOCKET_THREAD_WRITE, FALSE, nResult );
			break;
	}
}

void CClientThread::OnThreadQuit(WPARAM wParam, LPARAM lParam)
{
	//յ˳ָ

	//ɱ߳
	PostMessage( m_hMainWnd, WM_THREAD_QUIT, FALSE, MAKELONG(0, FALSE ) );
}

CString CClientThread::GetHost()
{
	return m_cTCPSocket.GetHost();
}

BOOL CClientThread::ChangeHandle()
{
	m_hMainWnd = m_hFinalWnd;
	return m_cTCPSocket.ChangeHandle();
}
