// TCPSocket.cpp : implementation file
//

#include "stdafx.h"
#include "Chat.h"
#include "TCPSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTCPSocket

/*

		TCPsocketװصƲWSAAsyncSelect
		ɴ->߳->->
 */

CTCPSocket::CTCPSocket()
{
	m_hMainWnd = NULL;
	m_bState = SOCKET_ORIGIN;
	m_bSocketType = SOCKET_CLIENT;
	m_nErrorCode = SOCKET_ERROR_NOERROR;
	m_TCP_s = INVALID_SOCKET;
	m_hWaitEvent = CreateEvent( NULL, TRUE, FALSE, NULL );
	m_lpReceiveBuffer = NULL;
	m_lpSendBuffer = NULL;
	m_nBegin = 0;
	m_nEnd = 0;
	m_szHost = _T("");
}

CTCPSocket::~CTCPSocket()
{
	CloseHandle( m_hWaitEvent );
	Close();
	if( m_lpReceiveBuffer ) 
	{ 
			GlobalFree( m_lpReceiveBuffer );
			m_lpReceiveBuffer = NULL;
	}
	if( m_lpSendBuffer ) 
	{
			GlobalFree( m_lpSendBuffer );
			m_lpSendBuffer = NULL;
	}
}



/////////////////////////////////////////////////////////////////////////////
// CTCPSocket member functions

int CTCPSocket::GetLastError()
{
	//ӦۺϿWSAGetLastErrorm_nErrorCode;
	return	m_nErrorCode;
}

BOOL CTCPSocket::CreateClient(CString szHost, int nPort, BOOL bUseProxy, HWND hWnd, HWND hFinalWnd)
{
	//ͻˣ߳Χá
	//hWndϢھ


	int		nResult;
	BOOL	bTemp;
	CString szTemp;

	/////  m_hWndҽӺú
	/////  SOCKET_THREAD_TRANSFERϢ
	m_hFinalWnd = hFinalWnd;
	m_bUseProxy = bUseProxy;

	////////////////////////////////////////////////////
	//Step 0 
	////////////////////////////////////////////////////
	ASSERT( m_TCP_s == INVALID_SOCKET );
	
	m_hMainWnd = hWnd;

	m_lpReceiveBuffer = (LPBYTE)GlobalAlloc( GPTR, MAX_PACKET_SIZE*4 );
	if( !m_lpReceiveBuffer )
	{
		m_nErrorCode = SOCKET_ERROR_CREATE;
		return FALSE;
	}
	m_lpSendBuffer = (LPBYTE)GlobalAlloc( GPTR, MAX_PACKET_SIZE+1 );
	if( !m_lpSendBuffer )
	{
		m_nErrorCode = SOCKET_ERROR_CREATE;
		return FALSE;
	}


	////////////////////////////////////////////////////

	////////////////////////////////////////////////////
	//Step 1 
	//
	//ͼ
	////////////////////////////////////////////////////
	m_bState = SOCKET_GETNAME;

	//ûҪӵ
	m_szHost = szHost;
	m_nPort = nPort;

	// ôӴ
	if( bUseProxy ) szTemp = confChat.szProxyIP;
	else			szTemp = szHost;

	//ȥ߿ո
	szTemp.TrimLeft();
	szTemp.TrimRight();

	//ȽѾipֱӼõipServer
	bTemp = GetHostIP( szTemp );
	//ִ
	if( !bTemp ) 
	{
		m_nErrorCode = SOCKET_ERROR_HOSTNAME;
		return FALSE;
	}
	////////////////////////////////////////////////////

	////////////////////////////////////////////////////
	////  Step 2 
	////  ܱܾTIMEOUT
	////////////////////////////////////////////////////
	
	///////SOCKET
	//////---------------------------
	m_TCP_s = socket( PF_INET, SOCK_STREAM, IPPROTO_TCP );
	if( m_TCP_s == INVALID_SOCKET )
	{
		////////////ʧ
		m_nErrorCode = SOCKET_ERROR_CREATE;
		return FALSE;
	}

	//////ӷʽ
	struct	sockaddr_in dummy;
	
	dummy.sin_addr = ipServer;
	dummy.sin_family = AF_INET;
	if( bUseProxy ) dummy.sin_port = htons( confChat.nProxyPort );
	else			dummy.sin_port = htons( nPort );

	//////FD_CONNECTϢ
	nResult = WSAAsyncSelect(
					m_TCP_s, 
					m_hMainWnd, 
					SOCKET_THREAD_CONNECT, 
					FD_CONNECT|FD_WRITE
				);
	if( nResult == SOCKET_ERROR )
	{
		m_nErrorCode = SOCKET_ERROR_CREATE;
		return FALSE;
	}

	///////Ϣɹʼ 
	nResult = connect( 
					m_TCP_s, 
					(LPSOCKADDR)&dummy, 
					sizeof(dummy) 
				);
	if( nResult != SOCKET_ERROR )
	{
		m_nErrorCode = SOCKET_ERROR_CONNECT;
		return FALSE;
	}
	///////첽Ƿȷ
	nResult = WSAGetLastError();
	if( nResult != WSAEWOULDBLOCK )
	{
		m_nErrorCode = SOCKET_ERROR_CONNECT;
		return FALSE;
	}

	////////Ѿú첽ʽӣʼȴ
	m_bState = SOCKET_CONNECTING;

	//ȴʱõĶһ
	m_bCancelJob = FALSE;
	ResetEvent( m_hWaitEvent );
	nResult = WaitForSingleObject( m_hWaitEvent, confChat.nWaitTime*2000 );
	ASSERT( nResult != WAIT_TIMEOUT );
	
	//////пûȡߣʱ䵽
	if( m_bCancelJob )
	{
		m_nErrorCode = SOCKET_ERROR_CANCEL;
		return FALSE;
	}

	nResult = WSAGetLastError();
	if( nResult&&(nResult!=WSAEWOULDBLOCK) )
	{
		//ӳ
		switch( nResult )
		{
		case WSAECONNREFUSED:
			//ܾ
			m_nErrorCode = SOCKET_ERROR_REFUSE;
			break;
		case WSAETIMEDOUT:
			m_nErrorCode = SOCKET_ERROR_TIMEOUT;
			break;
		default:
			m_nErrorCode = SOCKET_ERROR_UNKNOWN;
			break;
		}
		return FALSE;
	}
	////////ڹ涨ʱӳɹ
	//////첽Ϣ

	WSAAsyncSelect( m_TCP_s , m_hMainWnd, 0, 0 );

	if( m_bUseProxy == FALSE )m_hMainWnd = m_hFinalWnd;

	nResult = WSAAsyncSelect( 
					m_TCP_s, 
					m_hMainWnd, 
					SOCKET_THREAD_TRANSFER, 
					FD_READ|FD_WRITE|FD_CLOSE
				);
	if( nResult == SOCKET_ERROR )
	{
		m_nErrorCode = SOCKET_ERROR_CONNECT;
		return FALSE;
	}  

	////////////Ѿȫ
	////////////Կʼд

	//ʹôʱ֧

	//ֱӷһݰ
	if( m_bUseProxy )
	{
		nResult = SendFirstPacket();
		::PostMessage( m_hMainWnd, SOCKET_THREAD_WRITE,
			(nResult == 0), nResult );
	}


	m_bState = SOCKET_CONNECTED;
	m_bSocketType = SOCKET_CLIENT;
	m_bCanWrite = TRUE;

	return TRUE;
}

BOOL CTCPSocket::CreateServer(int nPort, HWND hWnd)
{
	//߳Χá
	//hWndϢھ
	int nResult;
	SOCKADDR_IN	addrLocal;

	////////////////////////////////////////////////////
	//Step 0 
	////////////////////////////////////////////////////
	ASSERT( m_TCP_s == INVALID_SOCKET );
	
	m_hMainWnd = hWnd;
	m_nPort = nPort;

	////////////////////////////////////////////////////
	///Step 1 SOCKET
	////////////////////////////////////

	
	m_TCP_s =  socket(PF_INET,SOCK_STREAM,IPPROTO_TCP);
	if( m_TCP_s == INVALID_SOCKET )
	{
		m_nErrorCode = SOCKET_ERROR_CREATE;
		return FALSE;
	}

	m_bState = SOCKET_INIT;

	////////////////////////////////////////////////////
	///Step 2 õַ
	////////////////////////////////////

	addrLocal.sin_family = AF_INET;
	addrLocal.sin_port = htons( m_nPort );
	addrLocal.sin_addr.s_addr = INADDR_ANY;

	////////////////////////////////////////////////////
	///Step 3 󶨶˿
	////////////////////////////////////

	nResult = bind( m_TCP_s,(LPSOCKADDR)&addrLocal,sizeof(addrLocal) );
	if( nResult == SOCKET_ERROR )     
	{
		m_nErrorCode = SOCKET_ERROR_CREATE;
		return FALSE;
	}

	////////////////////////////////////////////////////
	///Step 4 ˿
	////////////////////////////////////

	nResult = listen( m_TCP_s, SOMAXCONN );
	if( nResult == SOCKET_ERROR )
	{
		m_nErrorCode = SOCKET_ERROR_CREATE;
		return FALSE;
	}

	////////////////////////////////////////////////////
	///Step 5 첽ȴ
	////////////////////////////////////

	if( WSAAsyncSelect ( m_TCP_s, m_hMainWnd, SOCKET_THREAD_ACCEPT, FD_ACCEPT ) == SOCKET_ERROR )
	{
		m_nErrorCode = SOCKET_ERROR_CREATE;
		return FALSE;
	}

	m_bState = SOCKET_ACCEPTING;
	m_bSocketType = SOCKET_SERVER_LISTEN;
	return TRUE;
}




void CTCPSocket::Close()
{
	if( m_TCP_s != INVALID_SOCKET ) 
	{
		if( (m_bState == SOCKET_ACCEPTING)||
			(m_bState == SOCKET_CONNECTED) )
		{
			WSAAsyncSelect( m_TCP_s, m_hMainWnd, 0, 0 );
		}
		closesocket(m_TCP_s);
		m_TCP_s = INVALID_SOCKET;
	}
}

BOOL CTCPSocket::GetHostIP(CString szHost)
{
	int		iLen;
	int		i;
	BOOL	bIP;
	int		nNumber;  
	struct	hostent *ip;
	DWORD	dwIP;
	char	buf[MAXGETHOSTSTRUCT];
	HANDLE	hResolve;
	LPCTSTR lpHost = (LPCTSTR)szHost;
	int		nResult;

	//Ч
	if( lpHost == NULL )  return FALSE; 

	//ȼַΪIPַ

	//㳤
	iLen = strlen(lpHost);
	if(  iLen == 0 )  return FALSE; 
	//жǷΪֵIP
	bIP = TRUE;
	nNumber = 0;   //ĵַеĸ
	for(i=0;i<iLen;i++)
	{
			if(   (lpHost[i]<'0')||(lpHost[i]>'9')    ) 
			{
				/* жǷΪ0-9ַ. */
				/* lpHost */
				if( lpHost[i] == '.' ) nNumber++;
				else		 
				{
					bIP = FALSE;
					break;
				}
			}
	}
	// IPַ
	if( bIP == TRUE )
	{
		//'.'Ų3϶⣬IPv4
		if( nNumber != 3 )  return FALSE;
		else
		{
			dwIP = inet_addr( lpHost );
			// IPַ
			if( dwIP == INADDR_NONE ) return FALSE;
			ipServer = *((LPIN_ADDR)&dwIP);
			return TRUE;
		}
	}

	////////////////////////////////////////////
	// 
	/////////////////////

	//첽
	hResolve = WSAAsyncGetHostByName( 
					m_hMainWnd,			    //handle
					SOCKET_THREAD_RESOLVE,  //message
				    lpHost,					//source
					buf,					//result
					MAXGETHOSTSTRUCT );
	if( hResolve == 0 ) return FALSE;


	//ʼȴڴϢ
	// ע⣺
	// ûѡȡm_bCancelJob = TRUE
	m_bCancelJob = FALSE;
	ResetEvent( m_hWaitEvent );		
    nResult = WaitForSingleObject( m_hWaitEvent, confChat.nWaitTime*2000);
	ASSERT( nResult != WAIT_TIMEOUT );
	
	if( nResult == WAIT_TIMEOUT )
	{
			m_bState = SOCKET_ERROR_TIMEOUT;
			return FALSE;
	}

	// ȡ
	if( m_bCancelJob == TRUE ) 
	{
			WSACancelAsyncRequest( hResolve );
			return FALSE;
	}

	// ɹ
	ip = (struct hostent *)buf;
	// ĵַIPַ
	if( ip->h_length != sizeof(IN_ADDR) ) 
	{
		return FALSE;
	}
	memcpy( (void *)&ipServer, (void *)(ip->h_addr_list[0]) , ip->h_length );
	return TRUE;
}

void CTCPSocket::Stop()
{

	SetEvent( m_hWaitEvent );
	m_bCancelJob = TRUE;
}

void CTCPSocket::StopWait()
{

	SetEvent( m_hWaitEvent );
	m_bCancelJob = FALSE;
}

SOCKET CTCPSocket::GetSocket()
{
	return m_TCP_s;
}

BOOL CTCPSocket::CreateTransfer(CTCPSocket *pSocket, HWND hWnd, BOOL bAsync)
{

	//pSocketSERVERsocket࣬hWndھ
	int		nLength = sizeof(SOCKADDR_IN);
	SOCKADDR_IN	sockClient;
	int		nResult;

	if( pSocket == NULL ) return FALSE;

	m_lpReceiveBuffer = (LPBYTE)GlobalAlloc( GPTR, MAX_PACKET_SIZE*4 );
	if( !m_lpReceiveBuffer )
	{
		m_nErrorCode = SOCKET_ERROR_CREATE;
		return FALSE;
	}
	m_lpSendBuffer = (LPBYTE)GlobalAlloc( GPTR, MAX_PACKET_SIZE+1 );
	if( !m_lpSendBuffer )
	{
		m_nErrorCode = SOCKET_ERROR_CREATE;
		return FALSE;
	}

	m_TCP_s = accept( pSocket->GetSocket(), (LPSOCKADDR)&sockClient, &nLength);
	if( m_TCP_s == INVALID_SOCKET )
	{
		//׽Ч
		m_nErrorCode = SOCKET_ERROR_ACCEPT;
		return FALSE;
	}

	///öԷIPַ浽m_szHost
	ipClient = sockClient.sin_addr;
	m_szHost.Format( "%d.%d.%d.%d",
					ipClient.S_un.S_un_b.s_b1,
					ipClient.S_un.S_un_b.s_b2,
					ipClient.S_un.S_un_b.s_b3,
					ipClient.S_un.S_un_b.s_b4 );

	if( bAsync == FALSE ) 
	{
		//첽ʽ
		//Ѿ
		m_bSocketType = SOCKET_SERVER_TRANSFER;
		m_bState = SOCKET_CONNECTED;
		m_bCanWrite = TRUE;
		return TRUE;
	}

	////////////첽
	/////
	////////////////////////////////////
	m_hMainWnd = hWnd;


	nResult = WSAAsyncSelect( m_TCP_s, hWnd, SOCKET_THREAD_TRANSFER, FD_READ|FD_WRITE|FD_CLOSE );
	if( nResult == SOCKET_ERROR )
	{
		m_nErrorCode = SOCKET_ERROR_ACCEPT;
		Close();
		return FALSE;
	}

	////////ɹ
	/////////Կʼշ
	///////////////////////////
	m_bSocketType = SOCKET_SERVER_TRANSFER;
	m_bState = SOCKET_CONNECTED;
	m_bCanWrite = TRUE;

	return TRUE;
}

CString CTCPSocket::GetHost()
{
	return m_szHost;
}



BOOL CTCPSocket::Receive()
{
	int nResult;

	//ݴжm_lpReceiveBuffer

	if( !m_lpReceiveBuffer ) return FALSE;

	nResult = recv( m_TCP_s, 
					(char *)(m_lpReceiveBuffer+m_nEnd), 
					MAX_PACKET_SIZE, 
					0 
				);

	ASSERT( nResult != 0 );

	m_nEnd+=nResult;

	//ΰݴԻǹؼ

	return (nResult!=0);

}

int CTCPSocket::Send(LPBYTE lpBuf, int nLen)
{
	//lpBufгΪnLenֽڵݷ
	int nResult;
	LPBYTE lpTemp;
	int nSendLen;

	if( m_bCanWrite == FALSE ) return SOCKET_ERROR_SEND;
	if( nLen == 0 ) return SOCKET_ERROR_SEND;
	if( nLen > MAX_PACKET_SIZE ) return SOCKET_ERROR_SEND;
	if( lpBuf == NULL ) return SOCKET_ERROR_SEND;
	

	memcpy( m_lpSendBuffer, lpBuf, nLen );
	lpTemp = m_lpSendBuffer;
	nSendLen = nLen;
	//ȴFD_WRITE
	

	while( 1 )
	{
		nResult = send( m_TCP_s, (char *)lpTemp, nSendLen, 0 );
		//緢
		if( nResult == 0 ) return SOCKET_ERROR_CLOSE;
		if( nResult == SOCKET_ERROR )
		{
			nResult = WSAGetLastError();
			switch( nResult )
			{
			case WSAEWOULDBLOCK:
				m_bCanWrite = FALSE;
				return SOCKET_ERROR_BLOCK;
			case WSAENETRESET:
				return SOCKET_ERROR_RESET;
			default:
				return SOCKET_ERROR_SEND;
			}
		}
		if( nResult < nSendLen )
		{
			lpTemp+=nResult;
			nSendLen-=nResult;
		}
		else 
		{
			return SOCKET_ERROR_NOERROR;	
		}
	}
}

void CTCPSocket::EnableWrite()
{
	m_bCanWrite = TRUE;
}

LPBYTE CTCPSocket::GetData(int *nLen)
{
	LPBYTE lpTemp = NULL;


	if( m_lpReceiveBuffer == NULL ) return NULL;
	if( m_nBegin == m_nEnd ) return NULL;

	if( m_nEnd-m_nBegin > MAX_PACKET_SIZE )
	{
		*nLen = MAX_PACKET_SIZE;
	}
	else  *nLen = m_nEnd-m_nBegin;
	lpTemp = m_lpReceiveBuffer+m_nBegin;
	m_nBegin = 0;
	m_nEnd = 0;
	return lpTemp;
}

int CTCPSocket::SendFirstPacket()
{
	//
	char buf[300];
	int  nBytes;

	if(  
	  		(confChat.bProxyUsable == PROXY_AUTH_UNSET)
		   ||(confChat.bProxyUsable == PROXY_AUTH_NOPASS)
	  )
	{
			memset( buf, 0, 300 );
			wsprintf( buf, "%s%s:%d%s",
						"CONNECT ",
						m_szHost,
						m_nPort,
						" HTTP/1.1\r\nUser-Agent: NetChat/0.1\r\n\r\n");
			nBytes = strlen( buf );
			return Send((LPBYTE)buf, nBytes );
	}
	else
	{
			memset( buf, 0, 300 );
			wsprintf( buf, "%s%s:%d%s%s\r\n\r\n",
						"CONNECT ",
						m_szHost,
						m_nPort,
						" HTTP/1.1\r\nUser-Agent: PCTel/0.3\r\n",
						(LPSTR)(LPCTSTR)confChat.szProxyPass
						);
			nBytes = strlen( buf );
			return Send((LPBYTE)buf, nBytes);
		}
}

BOOL CTCPSocket::ChangeHandle()
{
	int nResult;

	if( m_TCP_s == INVALID_SOCKET) return FALSE;
	if( m_bSocketType != SOCKET_CLIENT ) return FALSE;
	if( m_bState != SOCKET_CONNECTED ) return FALSE;
	if( m_bUseProxy == FALSE ) return FALSE;

	WSAAsyncSelect( m_TCP_s , m_hMainWnd, 0, 0 );

	m_hMainWnd = m_hFinalWnd;
	nResult = WSAAsyncSelect( 
					m_TCP_s, 
					m_hMainWnd, 
					SOCKET_THREAD_TRANSFER, 
					FD_READ|FD_WRITE|FD_CLOSE
				);
	if( nResult == SOCKET_ERROR )
	{
		m_nErrorCode = SOCKET_ERROR_CONNECT;
		return FALSE;
	}
	return TRUE;
}
